var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/platform-browser'), require('ionic-angular/gestures/gesture')) :
        typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/platform-browser', 'ionic-angular/gestures/gesture'], factory) :
            (factory((global.angular2Modal = global.angular2Modal || {}), global.ng.core, global.ng.platformBrowser, global.ionicAngular_gestures_gesture));
}(this, (function (exports, _angular_core, _angular_platformBrowser, ionicAngular_gestures_gesture) {
    'use strict';
    var CardComponent = (function () {
        function CardComponent(el) {
            this.el = el;
            this.orientation = 'xy';
            this.fixed = false;
            this.onRelease = new _angular_core.EventEmitter();
            this.onSwipe = new _angular_core.EventEmitter();
            this.element = el.nativeElement;
        }
        CardComponent.prototype.translate = function (params) {
            if (!this.fixed) {
                this.element.style["transition"] = "transform " + (params.time || 0) + "s ease";
                this.element.style["webkitTransform"] = "translate3d(" +
                    (params.x && (!this.orientation || this.orientation.indexOf("x") != -1) ? (params.x) : 0) +
                    "px, " +
                    (params.y && (!this.orientation || this.orientation.indexOf("y") != -1) ? (params.y) : 0) +
                    "px, 0) rotate(" +
                    params.rotate +
                    "deg)";
            }
        };
        CardComponent.prototype.onSwipeCb = function (event) {
            var rotate = ((event.deltaX * 20) / this.element.clientWidth);
            this.translate({
                x: event.deltaX,
                y: event.deltaY,
                rotate: rotate
            });
        };
        CardComponent.prototype.onReleaseCb = function (event) {
            this.element.style["transition"] = "transform 0.2s ease";
        };
        CardComponent.prototype.ngOnInit = function () {
            var _this = this;
            // Set gestures
            this.swipeGesture = new ionicAngular_gestures_gesture.Gesture(this.element);
            this.swipeGesture.listen();
            this.swipeGesture.on("pan", function (event) {
                if (!_this.fixed) {
                    if (_this.onSwipeCb) {
                        _this.onSwipeCb(event);
                    }
                    if (_this.onSwipe) {
                        _this.onSwipe.emit(event);
                    }
                }
            });
            this.swipeGesture.on("panend", function (event) {
                if (!_this.fixed) {
                    if (_this.onReleaseCb) {
                        _this.onReleaseCb(event);
                    }
                    if (_this.onRelease) {
                        _this.onRelease.emit(event);
                    }
                }
            });
        };
        CardComponent.prototype.ngAfterViewChecked = function () {
            var el = this.element;
            if (this.element.parentElement) {
                el.style['height'] = el.parentElement.clientHeight + 'px';
                el.style['width'] = el.parentElement.clientWidth + 'px';
            }
        };
        CardComponent.prototype.ngOnDestroy = function () {
            this.swipeGesture.destroy();
        };
        return CardComponent;
    }());
    CardComponent.decorators = [
        { type: _angular_core.Component, args: [{
                    template: '<ng-content></ng-content>',
                    selector: 'mb-card',
                    styles: [':host {\
      transition: transform 1s ease;\
      position: absolute;\
      border-radius: 2px;\
      border: 1px solid white;\
      box-shadow: 0 1px 3px rgba(0, 0, 0, 0.3);\
      transition: transform 0.2s ease;\
    }\
  ']
                },] },
    ];
    /** @nocollapse */
    CardComponent.ctorParameters = [
        { type: _angular_core.ElementRef, },
    ];
    CardComponent.propDecorators = {
        'orientation': [{ type: _angular_core.Input },],
        'fixed': [{ type: _angular_core.Input },],
        'onRelease': [{ type: _angular_core.Output },],
        'onSwipe': [{ type: _angular_core.Output },],
    };
    var TinderCardComponent = (function (_super) {
        __extends(TinderCardComponent, _super);
        function TinderCardComponent(el) {
            _super.call(this, el);
            this.onReleaseLike = new _angular_core.EventEmitter();
            this.onSwipeLike = new _angular_core.EventEmitter();
            var self = this;
            self.orientation = "x";
            self.onReleaseLikeCb = function (event) {
                self.like = event.like;
                var el = self.element;
                var x = (el.offsetWidth + el.clientWidth) * ((!!event.like ? 1 : -1) || 0);
                var rotate = (x * 20) / el.clientWidth;
                self.translate({
                    x: x,
                    y: 0,
                    rotate: rotate,
                    time: 0.8
                });
                if (self.overlay) {
                    var overlayElm = self.element.querySelector('.tinder-overlay');
                    overlayElm.style["transition"] = "opacity 0.6s ease";
                    overlayElm.style["opacity"] = "0.5";
                }
            };
            self.onSwipeLikeCb = function (event) {
                if (self.overlay) {
                    var overlayElm = self.element.querySelector('.tinder-overlay');
                    overlayElm.style["transition"] = "opacity 0s ease";
                    var opacity = (event.distance < 0 ? event.distance * -1 : event.distance) * 0.5 / self.element.offsetWidth;
                    overlayElm.style.opacity = opacity.toString();
                }
            };
        }
        TinderCardComponent.prototype.onReleaseLikeCb = function (event) {
            this.like = event.like;
            var el = this.element;
            var x = (el.offsetWidth + el.clientWidth) * ((!!event.like ? 1 : -1) || 0);
            var rotate = (x * 20) / el.clientWidth;
            this.translate({
                x: x,
                y: 0,
                rotate: rotate,
                time: 0.8
            });
            if (this.overlay) {
                var overlayElm = this.element.querySelector('.tinder-overlay');
                overlayElm.style["transition"] = "opacity 0.6s ease";
                overlayElm.style.opacity = "0.5";
            }
        };
        TinderCardComponent.prototype.onSwipeLikeCb = function (event) {
            if (this.overlay) {
                var overlayElm = this.element.querySelector('.tinder-overlay');
                overlayElm.style["transition"] = "opacity 0s ease";
                var opacity = (event.distance < 0 ? event.distance * -1 : event.distance) * 0.5 / this.element.offsetWidth;
                overlayElm.style.opacity = opacity.toString();
            }
        };
        TinderCardComponent.prototype.ngOnInit = function () {
            var _this = this;
            _super.prototype.ngOnInit.call(this);
            var self = this;
            self.onRelease.subscribe(function (event) {
                var halfClientWidth = self.element.clientWidth / 2;
                var isOut = event.deltaX > halfClientWidth || event.deltaX < (-1 * halfClientWidth);
                if (isOut) {
                    _this.like = event.like = event.deltaX > 0;
                    if (_this.onReleaseLikeCb) {
                        _this.onReleaseLikeCb(event);
                    }
                    if (_this.onReleaseLike) {
                        _this.onReleaseLike.emit(event);
                    }
                }
                else {
                    if (_this.overlay) {
                        var overlayElm = self.element.querySelector('.tinder-overlay');
                        overlayElm.style["transition"] = "opacity 0.2s ease";
                        overlayElm.style.opacity = "0";
                    }
                    _this.translate({
                        x: 0,
                        y: 0,
                        rotate: 0,
                        time: 0.2
                    });
                }
            });
            this.onSwipe.subscribe(function (event) {
                _this.like = event.like = event.deltaX > 0;
                if (_this.onSwipeLikeCb) {
                    _this.onSwipeLikeCb(event);
                }
                if (_this.onSwipeLike) {
                    _this.onSwipeLike.emit(event);
                }
            });
            if (this.onLike) {
                this.onLike.subscribe(function (event) {
                    _this.onReleaseLikeCb(event);
                });
            }
        };
        TinderCardComponent.prototype.ngOnDestroy = function () {
            _super.prototype.ngOnDestroy.call(this);
            var self = this;
            self.onLike.unsubscribe();
        };
        return TinderCardComponent;
    }(CardComponent));
    TinderCardComponent.decorators = [
        { type: _angular_core.Component, args: [{
                    template: ' \
  <div *ngIf="overlay" class="card-heap tinder-overlay" [style.background-color]="overlay[like ? \'like\' : \'dislike\'].backgroundColor"> \
    <img src="{{overlay[like ? \'like\' : \'dislike\'].img}}" /> \
  </div> \
  <ng-content></ng-content> \
  ',
                    selector: 'mb-tinder-card',
                    styles: ['.tinder-overlay { \
    transform: translateZ(0); \
    opacity: 0; \
    border-radius: 2px; \
    position: absolute; \
    width: calc(100%); \
    height: calc(100%); \
    top: 0; \
    left: 0; \
    display: flex; \
    align-items: center; \
    justify-content: center; \
    overflow: hidden; \
    color: white; \
  } .tinder-overlay img { \
    width:60px \
  }', ':host {\
    transition: transform 1s ease;\
  }\
  :host:nth-child(1) {\
    box-shadow: 0 1px 3px rgba(0, 0, 0, 0.3) !important;\
    z-index:3;\
    transform: perspective(400px) translate3d(0, 0px, 0px);\
  }\
  :host:nth-child(2) {\
    box-shadow: 0 1px 3px rgba(0, 0, 0, 0.3) !important;\
    z-index:2;\
    transform: perspective(400px) translate3d(0, 30px, -30px);\
  }\
  :host:nth-child(3) {\
    box-shadow: 0 1px 3px rgba(0, 0, 0, 0.3) !important;\
    z-index:1;\
    transform: perspective(400px) translate3d(0, 60px, -60px);\
  }\
  :host:nth-child(n+4) {\
    box-shadow: 0 0 0 rgba(0, 0, 0, 0) !important;\
    transform: perspective(400px) translate3d(0, 30px, -30px);\
  }\
']
                },] },
    ];
    /** @nocollapse */
    TinderCardComponent.ctorParameters = [
        { type: _angular_core.ElementRef, },
    ];
    TinderCardComponent.propDecorators = {
        'overlay': [{ type: _angular_core.Input },],
        'onLike': [{ type: _angular_core.Input },],
        'onReleaseLike': [{ type: _angular_core.Output },],
        'onSwipeLike': [{ type: _angular_core.Output },],
    };
    var MobileCardModule = (function () {
        function MobileCardModule() {
        }
        return MobileCardModule;
    }());
    MobileCardModule.decorators = [
        { type: _angular_core.NgModule, args: [{
                    imports: [
                        _angular_platformBrowser.BrowserModule
                    ],
                    declarations: [
                        CardComponent,
                        TinderCardComponent
                    ],
                    exports: [
                        CardComponent,
                        TinderCardComponent
                    ],
                    entryComponents: [
                        CardComponent,
                        TinderCardComponent
                    ]
                },] },
    ];
    /** @nocollapse */
    MobileCardModule.ctorParameters = [];
    exports.MobileCardModule = MobileCardModule;
    Object.defineProperty(exports, '__esModule', { value: true });
})));
